/* $Id: AddAction.hh,v 1.2 2003/08/31 19:20:28 pklaus Exp $
 *
 * AddAction.hh
 *
 * Gestalter - The free vector drawing application
 * Copyright (c) 2002 Philipp Klaus <gestalter@linotux.ch>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */


#ifndef _ADDACTION_HH
#  define _ADDACTION_HH

#include "GDAction.hh"

class GObject;
class Layer;
class BezierPath;
class BezierNode;
class SelectionItemList;

class AddAction : public GDAction {

	GObject *addObject;
	Layer *affectedLayer;
	BezierPath *appendPath;
	BezierNode *previousNode;
	BezierNode *newNode;
	SelectionItemList *pasteList;
	
public:
	AddAction(GObject *object, Layer *layer);
	AddAction(BezierPath *path, BezierNode *node);
	AddAction(BezierNode *pNode);
	AddAction(SelectionItemList *pasteList);
};

#endif
