/* $Id: BoundingBox.cc,v 1.6 2004/07/21 06:31:20 pklaus Exp $
 *
 * BoundingBox.cc
 *
 * Gestalter - The free vector drawing application
 * Copyright (c) 2002 Philipp Klaus <gestalter@linotux.ch>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */


#include "BoundingBox.hh"

BoundingBox::BoundingBox() {
	/* initialize the values */
	//g_printerr("BoundingBox::BoundingBox() initialising\n");
	left = G_MAXDOUBLE;
	top = G_MAXDOUBLE;
	right = G_MINDOUBLE;
	bottom = G_MINDOUBLE;

	//g_printerr("BoundingBox::BoundingBox(): %f,%f %f,%f (%lX)\n", left, top, right, bottom, this);
}

BoundingBox::BoundingBox(const BoundingBox& ob) {
	//g_printerr("BoundingBox::BoundingBox(BoundingBox&) copying\n");
	left = ob.left;
	top = ob.top;
	right = ob.right;
	bottom = ob.bottom;
}

void BoundingBox::combine(const RectangleArea& box) {
	if (box.left < left) {
		left = box.left;
	}
	if (box.top < top) {
		top = box.top;
	}
	if (box.right > right) {
		right = box.right;
	}
	if (box.bottom > bottom) {
		bottom = box.bottom;
	}
	//g_printerr("BoundingBox::combine end: %f,%f %f,%f\n", left, top, right, bottom);
}

void BoundingBox::include(position point) {
	if (left > point.x) left = point.x;
	if (right < point.x) right = point.x;
	if (top > point.y) top = point.y;
	if (bottom < point.y) bottom = point.y;
}
