/* $Id: DocumentMenu.hh,v 1.12 2004/04/19 19:57:56 pklaus Exp $
 *
 * DocumentMenu.hh
 *
 * Gestalter - The free vector drawing application
 * Copyright (c) 2002 Philipp Klaus <gestalter@linotux.ch>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */



#ifndef _DOCUMENTMENU_HH
#  define _DOCUMENTMENU_HH
#include <gtk--/menu.h>
#include "config.h"

class DocWindow;
class GDDocument;

class DocumentMenu : public Gtk::Menu {   

protected:
	SigC::Connection selConnection;

	
	public:
	Gtk::AccelGroup *DocumentMenu_accgrp;
	DocWindow *menuDocWindow;
	DocumentMenu();
	
	// menu items that may be disabled
	Gtk::MenuItem *SaveDocument;
	Gtk::MenuItem *UndoItem;
	Gtk::MenuItem *Redo;
	Gtk::MenuItem *Cut;
	Gtk::MenuItem *Copy;
	Gtk::MenuItem *Paste;
	Gtk::MenuItem *Clear;
	Gtk::MenuItem *RepeatCommand;
	Gtk::MenuItem *MoveObjects;
	Gtk::MenuItem *TransformSeparateObjects;
	Gtk::MenuItem *BringToFront;
	Gtk::MenuItem *RaiseObjects;
	Gtk::MenuItem *BringToBack;
	Gtk::MenuItem *LowerObjects;
	Gtk::MenuItem *GroupObjects;
	Gtk::MenuItem *Ungroup;
	Gtk::MenuItem *Lock;
	Gtk::MenuItem *Unlock;
	Gtk::MenuItem *Hide;
	Gtk::MenuItem *ShowAll;
	Gtk::MenuItem *MakeGuide;
	Gtk::MenuItem *ReleaseGuide;
	Gtk::MenuItem *MakeMask;
	Gtk::MenuItem *ReleaseMask;
	Gtk::MenuItem *MakeCombine;
	Gtk::MenuItem *ReleaseCombine;
	Gtk::MenuItem *ReversePathDirection;
	Gtk::MenuItem *JoinObjects;
	Gtk::MenuItem *Average;
	Gtk::MenuItem *CreateOutlines;
	Gtk::MenuItem *LeftJustify;
	Gtk::MenuItem *CenterJustify;
	Gtk::MenuItem *RightJustify;
	Gtk::MenuItem *TextJustificationSubmenu;
	Gtk::CheckMenuItem *LockGuides;
	Gtk::MenuItem *pathMingleUnite;
	Gtk::MenuItem *pathMingelIntersect;
	Gtk::MenuItem *pathMingleExclude;
	Gtk::MenuItem *pathMingleMinusFront;
	Gtk::MenuItem *pathMingleMinusBack;
	Gtk::MenuItem *pathMingleTrim;
	Gtk::MenuItem *pathMingleDivide;
	Gtk::MenuItem *pathMingleOutline;
	Gtk::MenuItem *pathMingleCrop;
	
	void setWindow(DocWindow *docwin);
	void updateItemSensitivity(GDDocument *doc);
	
	void onNewDocument();
	void onOpenDocument();
	void onSaveDocument();
	void onSaveDocumentAs();
	void onRevertDocument();
	void onPlace();
	void onPrintSetup();
	void onPrintDocument();
	void onCloseDocument();
	void onExit();
	void onUndo();
	void onRedo();
	void onCut();
	void onCopy();
	void onPaste();
	void onClear();
	void onSelectAll();
	void onDeselectAll();
	void onRepeatCommand();
	void onMoveObjects();
	void onTransformSeparateObjects();
	void onBringToFront();
	void onRaiseObjects();
	void onBringToBack();
	void onLowerObjects();
	void onGroupObjects();
	void onUngroup();
	void onLock();
	void onUnlock();
	void onHide();
	void onShowAll();
	void onRendered();
	void onWireframe();
	void onDisplayToggleTemplate();
	void onToggleGuides();
	void onTogglePageFrame();
	void onToggleAncors();
	void onZoomIn();
	void onZoomOut();
	void onNoScale();
	void onFitInWindow();
	void onNewView();
	void onReversePathDirection();
	void onObjectAttributes();
	void onJoinObjects();
	void onAverage();
	void onJustifyLeft();
	void onJustifyCenter();
	void onJustifyRight();
	void onCreateOutlines();
	void onMakeGuide();
	void onReleaseGuide();
	void onLockGuides();
	void onMakeMask();
	void onReleaseMask();
	void onMakeCombine();
	void onReleaseCombine();
	void onPathMingleUnite();
	void onPathMingleIntersect();
	void onPathMingleExclude();
	void onPathMingleMinusFront();
	void onPathMingleMinusBack();
	void onPathMingleTrim();
	void onPathMingleDivide();
	void onPathMingleOutline();
	void onPathMingleCrop();
	void onGraphicAttributesDialog();
	void onTextAttributesDialog();
	void onCustomColorsDialog();
	void onPatternsDialog();
	void onGradientsDialog();
	void onLayersDialog();
	void onAlignDistribute();
	void on_docmenu1_activate();
};
#endif
