/* $Id: Expat.hh,v 1.4 2003/01/19 15:33:38 pklaus Exp $
 *
 * Expat.hh
 *
 * Gestalter - The free vector drawing application
 * Copyright (c) 2002 Philipp Klaus <gestalter@linotux.ch>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */



#ifndef _EXPAT_HH
#  define _EXPAT_HH

#include <expat.h>
#include <string>
#include <sigc++/object.h>
#include <sigc++/basic_signal.h>
#include "gestalter.h"

#define MAX_TAG_SIZE	512

void wrapbegintag(void *mydata, const char *name, const char **attrs);
void wrapendtag(void *mydata, const char *name);

class GObject;

class ExpatXML : public SigC::Object {
	
protected:
	char tagname[MAX_TAG_SIZE];

public:
	XML_Parser parser;
	ExpatXML *parent;
	SigC::Signal1<void, GObject *> addObject;
	
	
	ExpatXML(ExpatXML *p, const char *tag, XML_Parser p, const char **attrs=NULL);
	ExpatXML();
	
	void init();
	void setParser(XML_Parser p);
	
	// working methods
	virtual void handleBeginTag(const char *name, const char **attrs);
	virtual void handleEndTag(const char *name);
	virtual void handleText(const char *text, int len);
	
	char *getAttributeValue(const char **attrs, const char *key);
	int getAttributeValue(const char **attrs, const char *key, int& value);
	int getAttributeValue(const char **attrs, const char *key, float& value);
	int getAttributeValue(const char **attrs, const char *key, double& value);
	int getAttributeValue(const char **attrs, const char *key, char *value, int len);
	
};

class Expat {
	XML_Parser parser;
	ExpatXML *rp;
	const char *errstring;
	
public:
	Expat();
	
	int parse(ExpatXML *rootParser, string filePath);
	
	~Expat();
};

#endif
