/* $Id: FontCache.hh,v 1.3 2005/05/07 17:39:32 pklaus Exp $
 *
 * FontCache.hh
 *
 * Gestalter - The free vector drawing application
 * Copyright (c) 2002 Philipp Klaus <gestalter@linotux.ch>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */



#ifndef _FONTCACHE_HH
#  define _FONTCACHE_HH

#include <gdk--.h>
#include <map>
#include <string>
#include "gestalter.h"

class Preferences;

#define FONTCACHE_VERSION	"1.2"

class FontCacheEntry {
public:
	string familyName;
	string printName;
	string fullName;
	string weight;
	string slant;
	gboolean isFixedPitch;
};

class FontCache {

struct ltstr {
	int operator()(const string s1, const string s2) const {
		return strcasecmp(s1.c_str(), s2.c_str()) < 0;
	}
};

typedef map<string, FontCacheEntry *, ltstr>	FCache;

public:
	FCache fontCacheMap;

	string savedversion;

	FontCache();

	void save(Preferences *prefs);

	void load(Preferences *prefs);

	~FontCache();
	
};

#endif
