/* $Id: FontPool.hh,v 1.10 2003/11/16 18:26:53 pklaus Exp $
 *
 * FontPool.hh
 *
 * Gestalter - The free vector drawing application
 * Copyright (c) 2002 Philipp Klaus <gestalter@linotux.ch>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */



#ifndef _FONTPOOL_HH
#  define _FONTPOOL_HH

#include <sigc++/object.h>
#include <map>
#include <vector>
#include <gtk--/base.h>
#include "gestalter.h"

class GDFont;
class GDApplication;
class Preferences;

struct ltstr {
	int operator()(const string s1, const string s2) const {
		return strcasecmp(s1.c_str(), s2.c_str()) < 0;
	}
};

typedef map<string, GDFont *, ltstr>	FontMap;
typedef map<string, FontMap, ltstr>	FamilyMap;
typedef map<string, FontMap, ltstr>::const_iterator	FamilyIterator;
typedef map<string, GDFont *, ltstr>::const_iterator	FontIterator;
class FontPool : public SigC::Object {

protected:
	FontMap		fontList;
	FamilyMap	familyList;
	GDApplication *application;
	
	vector<string> splitLine(string& input, string& delim);

public:

	FontPool(GDApplication *tw);
	
	GDFont *getFont(gchar *name);
	void onPrefsChanged(Preferences *newPrefs);
	void readFontLists();
	
	FamilyMap getFamilies() { return familyList; };
	
	~FontPool();
};


#endif
