/* $Id: FreeType.cc,v 1.2 2002/12/29 16:43:39 pklaus Exp $
 *
 * FreeType.cc
 *
 * Gestalter - The free vector drawing application
 * Copyright (c) 2002 Philipp Klaus <gestalter@linotux.ch>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */


#include "FreeType.hh"
#include "FTFace.hh"


FreeType::FreeType() {
	int error = FT_Init_FreeType(&freetype_library);
	if (error) {
		g_printerr("Error while initiating the FreeType library (%d)\n", error);
	}
}

FTFace *FreeType::getFontFace(gchar *fontFile, gint faceIndex) {
	FT_Face *face = (FT_Face *) g_malloc(sizeof(FT_Face));
	int error = FT_New_Face(freetype_library, fontFile, 0, face);
	if (error) {
		g_free(face);
		g_printerr("Cannot load font %s\n", fontFile);
		return NULL;
	} else {
		return new FTFace(face);
	}
}
