/* $Id: GDColor.hh,v 1.2 2004/03/07 21:35:33 pklaus Exp $
 *
 * GDColor.hh
 *
 * Gestalter - The free vector drawing application
 * Copyright (c) 2002 Philipp Klaus <gestalter@linotux.ch>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */



#ifndef _GDCOLOR_HH
#  define _GDCOLOR_HH

#include <gtk--.h>

#define GDCOLOR_TYPE_RGB		1
#define GDCOLOR_TYPE_CMYK		2
#define GDCOLOR_TYPE_BLACK		3
#define GDCOLOR_TYPE_WHITE		4
#define GDCOLOR_TYPE_CUSTOM		5


class CustomColor;

struct colortype_rgb {
	guint r;
	guint g;
	guint b;
};
struct colortype_cmyk {
	guint c;
	guint m;
	guint y;
	guint k;
};
union gds_color {
	colortype_rgb	rgb;
	colortype_cmyk	cmyk;
	CustomColor		*custom;
};


class GDColor {

	friend class GDStyle;
	
	gds_color color;

public:
	gint colorType;

	GDColor();

	GDColor(const GDColor& from);

	GDColor operator=(const GDColor& from);
	int operator==(const GDColor& b);

	void getRGBColor(guint& r, guint& g, guint& b) const;

	void setFromString(gchar *str);

	void setRGB(guint r, guint g, guint b);

	~GDColor();
};

#endif
