/* $Id: GDResource.hh,v 1.4 2004/03/06 15:00:19 pklaus Exp $
 *
 * GDResource.hh
 *
 * Gestalter - The free vector drawing application
 * Copyright (c) 2002 Philipp Klaus <gestalter@linotux.ch>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
 
#ifndef _GDRESOURCE_HH
#  define _GDRESOURCE_HH

#include "gestalter.h"
#include <iostream>
#include <glib.h>
#include <set>


class GDResource {

	guint resourceType;
	
public:
	GDResource(guint t) { resourceType = t; };
	
	guint getType() { return resourceType; };
	
	virtual gint writePS(ostream& psout) = 0;
	virtual gint writeXML(ostream& xmlout) = 0;
	
};


struct GDResourceCompare {
	bool operator()(GDResource* s1, GDResource* s2) const {
		return s1 < s2;
	}
};



typedef set<GDResource *, GDResourceCompare> GDResourceList;
typedef GDResourceList::const_iterator	GDResourceListIterator;

#define GDRESOURCE_TYPE_FONT		1
#define GDRESOURCE_TYPE_COLOR		2
#define GDRESOURCE_TYPE_GRADIENT	4
#define GDRESOURCE_TYPE_PATTERN		8

#endif
