/* $Id: GroupAction.cc,v 1.2 2004/02/12 08:17:08 pklaus Exp $
 *
 * GroupAction.cc
 *
 * Gestalter - The free vector drawing application
 * Copyright (c) 2002 Philipp Klaus <gestalter@linotux.ch>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include "GroupAction.hh"

GroupAction::GroupAction(ObjectGroup *oldGroup) {
	action = "Ungroup";
	group = oldGroup;
}
	
GroupAction::GroupAction() {
	action = "Group";
}

GroupAction::GroupAction(guint type) {
	if (type == GROUPACTION_TYPE_CLIPGROUP) {
		action = "ClipGroup";
	} else if (type == GROUPACTION_TYPE_COMPOUNDPATH) {
		action = "CompoundPath";
	} else {
		action = "Group";
	}
}

GroupAction::GroupAction(ClipGroup *oldClip) {
	action = "UnClipGroup";
	clip = oldClip;
}

GroupAction::GroupAction(CompoundPath *oldCompound) {
	action = "UnCompoundPath";
	compound = oldCompound;
}
