/* $Id: GroupAction.hh,v 1.1 2003/08/30 15:07:43 pklaus Exp $
 *
 * GroupAction.hh
 *
 * Gestalter - The free vector drawing application
 * Copyright (c) 2002 Philipp Klaus <gestalter@linotux.ch>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */


#ifndef _GROUPACTION_HH
#  define _GROUPACTION_HH

#include "GDAction.hh"

#define GROUPACTION_TYPE_OBJECTGROUP	0
#define GROUPACTION_TYPE_CLIPGROUP		1
#define GROUPACTION_TYPE_COMPOUNDPATH	2

class ObjectGroup;
class ClipGroup;
class CompoundPath;

class GroupAction : public GDAction {

protected:
	ObjectGroup *group;
	ClipGroup *clip;
	CompoundPath *compound;
	
public:
	GroupAction(ObjectGroup *oldGroup);

	GroupAction();

	GroupAction(guint type);

	GroupAction(ClipGroup *oldClip);

	GroupAction(CompoundPath *oldCompound);
};

#endif
