/* $Id: HWrapBox.hh,v 1.2 2002/12/29 16:43:39 pklaus Exp $
 *
 * HWrapBox.hh
 *
 * Gestalter - The free vector drawing application
 * Copyright (c) 2002 Philipp Klaus <gestalter@linotux.ch>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */



#ifndef _HWRAPBOX_HH
#  define _HWRAPBOX_HH

#include "WrapBox.hh"

class HWrapBox : public WrapBox {

private:
	void get_child_requisition(Gtk::Widget& child, GtkRequisition& child_requisition);
	gfloat get_layout_size(guint max_width, guint& width_inc);
	void layout_row(GtkAllocation& area, GSList *children,
					guint children_per_line, gboolean vexpand);
	void layout_rows(GtkAllocation& area);
	

protected:
	guint16		max_child_width;
	guint16		max_child_height;

public:
	HWrapBox(gboolean homogeneous);
	void size_request_impl(GtkRequisition *requisition);
	GSList *rlist_line_children(WrapBoxChild **child_p, GtkAllocation& area,
						guint& max_child_size, gboolean& expand_line);
	void size_allocate_impl(GtkAllocation* allocation);
	
	
};

#endif
