/* $Id: Layers.hh,v 1.7 2003/08/30 15:07:43 pklaus Exp $
 *
 * GDApplication.hh
 *
 * Gestalter - The free vector drawing application
 * Copyright (c) 2002 Philipp Klaus <gestalter@linotux.ch>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

// generated 2003/6/6 8:39:37 CEST by pklaus@iron.pylonsoft.ch.(none)
// using glademm V1.1.3d
//
// newer (non customized) versions of this file go to Layers.hh_new


#ifndef _LAYERS_HH
#  include "Layers_glade.hh"
#  define _LAYERS_HH

class GDApplication;
class GDDocument;
class LayerRename;

class Layers : public Layers_glade {  
	friend class Layers_glade;
	
public:	
	Layers(GDApplication *myApp);
protected:
	GDApplication *application;
	GDDocument *doc;
	SigC::Connection selConnection;
	SigC::Connection layerConnection;
	guint selectedRow;
	Gdk_Bitmap viewableMask;
	Gdk_Pixmap viewablePixmap;
	Gdk_Bitmap editableMask;
	Gdk_Pixmap editablePixmap;
	Gdk_Bitmap emptyMask;
	Gdk_Pixmap emptyPixmap;
	LayerRename *layerRenameDialog;
	guint layerCount;

	void onClickLayer(gint column);
	void onSelectLayer(gint row, gint column, GdkEvent *event);
	void onNewLayer();
	void onLayerUp();
	void onLayerDown();
	void onLayerDuplicate();
	void onLayerDelete();
	void resizeLayerList(GtkAllocation *all);
	gint hideLayers(GdkEventAny *ev);
	void closeLayersDialog();
	void checkButtons(guint selected);
	
public:	
	void setDocument(GDDocument *document);
	void updateLayers(GDDocument *document);
	void updateSelection(GDDocument *document);
	gint deleteLayerRenameDialog(GdkEventAny *ev);
	void cancelLayerRenameDialog();
	void renameLayer();

	~Layers();
};
#endif
