/* $Id: MorphTool.hh,v 1.1 2005/05/07 17:54:16 pklaus Exp $
 *
 * MorphTool.hh
 *
 * Gestalter - The free vector drawing application
 * Copyright (c) 2002 Philipp Klaus <gestalter@linotux.ch>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */



#ifndef _MORPHTOOL_HH
#  define _MORPHTOOL_HH

#include "Tool.hh"
#include "BezierNode.hh"
#include "MorphDialog.hh"

#define MORPH_TOOL_MODE_SOURCE	0
#define MORPH_TOOL_MODE_TARGET	1
#define MORPH_TOOL_MODE_DIALOG	2

class MorphTool : public Tool, public SigC::Object {

protected:

	Gdk_Cursor crosshairSourceCursor;
	Gdk_Cursor crosshairTargetCursor;
	Gdk_Cursor crosshairCursor;
	int	mode;
	gboolean nodeCaught;
	BezierNode *source;
	BezierNode *target;
	GDDocument *dialogDoc;
	MorphDialog *valueDialog;

	void doMorph();
	gint deleteValueDialog(GdkEventAny *ev);
	void cancelValueDialog();

public:
	
	MorphTool();
	
	void activate();
	void deactivate();
	gint buttonDown(GdkEventButton *ev, DocWindow *docwin);
	gint motion(GdkEventMotion *ev, DocWindow *docwin);
	gint buttonUp(GdkEventButton *ev, DocWindow *docwin);
	gint showOptions();
	
	void setCursor(guint state, DocWindow *docwin);
	
};

#endif
