/* $Id: PThreadMutex.cc,v 1.2 2002/12/29 16:43:39 pklaus Exp $
 *
 * PThreadMutex.cc
 *
 * Gestalter - The free vector drawing application
 * Copyright (c) 2002 Philipp Klaus <gestalter@linotux.ch>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */


#include "PThreadMutex.hh"

PThreadMutex::PThreadMutex(pthread_mutexattr_t* attr) {
	pthread_mutex_init(&pmutex, attr);
}

PThreadMutex::PThreadMutex() {
	pthread_mutex_init(&pmutex, NULL);
}

int PThreadMutex::lock() {
	return pthread_mutex_lock(&pmutex);
}

int PThreadMutex::trylock() {
	return pthread_mutex_trylock(&pmutex);
}

int PThreadMutex::unlock() {
	return pthread_mutex_unlock(&pmutex);
}

PThreadMutex::~PThreadMutex() {
	pthread_mutex_destroy(&pmutex);
}
