/* $Id: PageOriginTool.hh,v 1.2 2002/12/29 16:43:39 pklaus Exp $
 *
 * PageOriginTool.hh
 *
 * Gestalter - The free vector drawing application
 * Copyright (c) 2002 Philipp Klaus <gestalter@linotux.ch>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */



#ifndef _PAGEORIGINTOOL_HH
#  define _PAGEORIGINTOOL_HH

#include "Tool.hh"
#include "DocWindow.hh"
#include <gdk--.h>
#include "BezierNode.hh"

class PageOriginTool : public Tool {

protected:
	gint downButton;
	gint oldx, oldy;
	gdouble sx, sy;

	Gdk_Cursor pageOriginCursor;
	Gdk_Cursor moveCursor;

public:
	
	PageOriginTool();
	
	gint install();
	void activate();
	void deactivate();
	gint buttonDown(GdkEventButton *ev, DocWindow *docwin);
	gint motion(GdkEventMotion *ev, DocWindow *docwin);
	gint buttonUp(GdkEventButton *ev, DocWindow *docwin);
	gint showOptions();
	
	void setCursor(guint state, DocWindow *docwin);
	
};

#endif
