/* $Id: Preferences.hh,v 1.12 2004/03/24 19:31:43 pklaus Exp $
 *
 * Preferences.hh
 *
 * Gestalter - The free vector drawing application
 * Copyright (c) 2002 Philipp Klaus <gestalter@linotux.ch>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */



#ifndef _PREFERENCES_HH
#  define _PREFERENCES_HH

#include <gdk--.h>
#include <gtk--.h>
#include <map>
#include <vector>
#include <string>
#include "gestalter.h"



class Preferences {
private:
	map<string, gdouble> unitToFactorMap;
	
public:
	vector<string> units;
	vector<gdouble> factors;
	gdouble catchingRange;
	gdouble pageWidth;
	gdouble pageHeight;
	gdouble rulerUnitFactor;

	Gtk::Menu *unitPopupMenu;

	string pageFormat;

	string prefDir;
	guint undoStackSize;
	
	vector<string>	fontDir;
	
	guint textCursorBlinkTime; // in millisecs
	
	Preferences();
	
	gint createPrefDirectory();

	void save();

	void load();
	
	string getPrefDirectory();
	
	void setPageSizeFromFormat();
	
	gdouble unit2Factor(string unit);
	
	string factor2Unit(gdouble factor);
	
	gdouble unitStrToDouble(string str, gboolean fallbackDefault = true);
};

#endif
