/* $Id: RectangleArea.hh,v 1.1 2004/07/21 06:31:20 pklaus Exp $
 *
 * RectangleArea.hh
 *
 * Gestalter - The free vector drawing application
 * Copyright (c) 2002 Philipp Klaus <gestalter@linotux.ch>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */



#include "gestalter.h"
#include <glib--.h>

#ifndef _RECTANGLEAREA_HH
#  define _RECTANGLEAREA_HH

class RectangleArea {

public:
	gdouble left;
	gdouble top;
	gdouble right;
	gdouble bottom;
	
	RectangleArea();
	RectangleArea(const RectangleArea& from);
	RectangleArea(gdouble l, gdouble t, gdouble r, gdouble b);
	void do_intersect(const RectangleArea& with);
	gboolean intersect(const RectangleArea& with) const;
	gboolean contained(const RectangleArea& in) const;
	gboolean contains(gdouble x, gdouble y) const;
};

#endif
