/* $Id: SelectObjectTool.hh,v 1.2 2002/12/29 16:43:39 pklaus Exp $
 *
 * SelectObjectTool.hh
 *
 * Gestalter - The free vector drawing application
 * Copyright (c) 2002 Philipp Klaus <gestalter@linotux.ch>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */



#ifndef _SELECTOBJECTTOOL_HH
#  define _SELECTOBJECTTOOL_HH

#include "Tool.hh"
#include <gdk--.h>

class SelectableItem;
class SelectionItemList;
class DocWindow;

class SelectObjectTool : public Tool {

protected:
	gint startx, starty, oldx, oldy;
	gdouble sx, sy;

	Gdk_Cursor selectObjectCursor;
	Gdk_Cursor moveCursor;
	Gdk_Cursor moveMagnetCursor;
	Gdk_Cursor moveCopyCursor;
	Gdk_Cursor moveCopyMagnetCursor;
	
	SelectionItemList *selection;
	
	gboolean nodeCaught;
	gboolean shiftSelect;

public:
	SelectableItem *movingNode;
	SelectableItem *selectNode;
	
	SelectObjectTool();
	
	gint install();
	void activate();
	void deactivate();
	gint buttonDown(GdkEventButton *ev, DocWindow *docwin);
	gint motion(GdkEventMotion *ev, DocWindow *docwin);
	gint buttonUp(GdkEventButton *ev, DocWindow *docwin);
	gint showOptions();
	
	void setCursor(guint state, DocWindow *docwin);
	
};

#endif
