/* $Id: SelectionItemList.hh,v 1.12 2004/07/21 06:31:20 pklaus Exp $
 *
 * SelectionItemList.hh
 *
 * Gestalter - The free vector drawing application
 * Copyright (c) 2002 Philipp Klaus <gestalter@linotux.ch>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */



#ifndef _SELECTIONITEMLIST_HH
#  define _SELECTIONITEMLIST_HH

#include <gtk--/base.h>
#include "TransformationMatrix.hh"
#include "GDResource.hh"
#include "BoundingBox.hh"

#define GDPOSITION_RAISE	1
#define GDPOSITION_TOP		2
#define GDPOSITION_LOWER	-1
#define GDPOSITION_BOTTOM	-2

class SelectionItem;
class DocWindow;
class GDDocument;

class SelectionItemList : public G_List<SelectionItem *>, public SigC::Object {

	TransformationMatrix lastTM;
	gboolean lastTMSet;
	TransformationMatrix nextTransformation;
	guint newTransformation;
	BoundingBox area;
	DocWindow *currDocwin;
	Gdk_GC currContext;
	
public:
	SelectionItemList();

	gint idleDraw();
	
	void startTransformation(DocWindow *docwin, Gdk_GC& context);
	
	void endTransformation(DocWindow *docwin, Gdk_GC& context);
	
	void draw(DocWindow *docwin, Gdk_GC& context, RectangleArea& drawArea);
	
	void transformByMatrix(TransformationMatrix& m, gboolean incFillPattern = true);

	void transformByMatrixRelative(TransformationMatrix& m, gboolean incFillPattern = true);

	void setFillMatrix(TransformationMatrix& m);

	void transformAndDraw(DocWindow *docwin, Gdk_GC& context, TransformationMatrix& m, gboolean incFillPattern = true);

	TransformationMatrix getLastTransformation();

	void applyToOriginal();
	
	void clearOriginal();
	
	void insertMoving(GDDocument *doc);
	
	void changePosition(GDDocument *doc, gint what);

	void gatherResource(GDResourceList& collection, gint type);

	BoundingBox getBoundingBox();
	
	void reSelect();

	~SelectionItemList();
};

#endif
