/* $Id: SelectionList.hh,v 1.8 2004/07/21 06:31:20 pklaus Exp $
 *
 * SelectionList.hh
 *
 * Gestalter - The free vector drawing application
 * Copyright (c) 2002 Philipp Klaus <gestalter@linotux.ch>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */



#ifndef _SELECTIONLIST_HH
#  define _SELECTIONLIST_HH

#include <gtk--.h>
#include "RectangleArea.hh"

class DrawObject;
class DocWindow;
class Properties;
class GDDocument;
class GDStyle;
class GDFont;
class TextProperties;
class TextStyle;

typedef G_List_Iterator<DrawObject *>	SelectionIterator;

class SelectionList : public virtual SigC::Object {

	G_List<DrawObject *> *objects;
	GDDocument *doc;

public:
	SelectionList(GDDocument *document);

	void reset();
	
	void insertObject(DrawObject *object);
	void removeObject(DrawObject *object);
	SelectionIterator getIterator();
	
	void draw(DocWindow *docwin, RectangleArea& drawArea);
	void drawWireFrame(DocWindow *docwin, RectangleArea& drawArea);
	
	void fillProperties(Properties *properties);
	
	void setFillStyle(GDStyle *style);
	void setStrokeStyle(GDStyle *style);

	gboolean selectionNotEmpty();
	
	// TextProperties
	void setTextStyle(TextStyle& style);
	
	void fillTextProperties(TextProperties *textProperties);
	
	SigC::Signal1<void, GDDocument *> changed;
	SigC::Signal1<void, GDDocument *> textChanged;

	~SelectionList();

};

#endif
