/* $Id: ShearDialog.cc,v 1.3 2003/12/06 21:42:11 pklaus Exp $
 *
 * ShearDialog.cc
 *
 * Gestalter - The free vector drawing application
 * Copyright (c) 2002 Philipp Klaus <gestalter@linotux.ch>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */


#include "config.h"
#include "ShearDialog.hh"
#include <math.h>


Gtk::Button *ShearDialog::getOKButton() {
	return okButton;
}

Gtk::Button *ShearDialog::getCancelButton() {
	return cancelButton;
}

Gtk::Button *ShearDialog::getCopyButton() {
	return copyButton;
}

gdouble ShearDialog::getAxisAngle() {
	gdouble angle;
	if (horizontalRadio->get_active()) {
		angle = 0;
	} else if (verticalRadio->get_active()) {
		angle = 90;
	} else {
		angle = strtod(axisAngleEntry->get_text().c_str(), NULL);
	}
	angle = angle / 180 * M_PI;
	return angle;
}

gdouble ShearDialog::getAngle() {
	gdouble angle = strtod(angleEntry->get_text().c_str(), NULL);
	angle = angle / 180 * M_PI;
	return angle;
}
		
void ShearDialog::shearTypeToggled() {
	if (angleRadio->get_active()) {
		axisAngleEntry->set_sensitive(1);
	} else {
		axisAngleEntry->set_sensitive(0);
	}
}
