/* $Id: ShearTool.hh,v 1.3 2003/09/18 20:38:33 pklaus Exp $
 *
 * ShearTool.hh
 *
 * Gestalter - The free vector drawing application
 * Copyright (c) 2002 Philipp Klaus <gestalter@linotux.ch>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */



#ifndef _SHEARTOOL_HH
#  define _SHEARTOOL_HH

#include "TMatrixTool.hh"
#include "TransformationMatrix.hh"
#include "../pixmaps/shear.xpm"
#include "ShearDialog.hh"

class ShearTool : public TMatrixTool {

protected:
	ShearDialog *valueDialog;
	TransformationMatrix setMatrix(gdouble angle, gdouble axisAngle);

public:
	ShearTool();

	TransformationMatrix calcMatrix(gdouble sx, gdouble sy, 
						gdouble cx, gdouble cy,
						gdouble x, gdouble y, gint state);

	void showValueDialog();
	gint deleteValueDialog(GdkEventAny *ev);
	void cancelValueDialog();
	void transformObjects();
	void copyObjects();
};


#endif
