/* $Id: TextAction.hh,v 1.2 2003/08/31 19:20:28 pklaus Exp $
 *
 * TextAction.hh
 *
 * Gestalter - The free vector drawing application
 * Copyright (c) 2002 Philipp Klaus <gestalter@linotux.ch>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */


#ifndef _TEXTACTION_HH
#  define _TEXTACTION_HH

#include "GDAction.hh"
#include "TextStyle.hh"
#include "GDCharacter.hh"
#include <vector>

class TextObject;
class GDCharacter;

typedef enum {
	delete_forward,
	delete_backward
} textaction_deletetype;

class TextAction : public GDAction {

	TextStyle tStyle;
	TextObject *textObj;
	guint character;
	textaction_deletetype dtype;
	vector<GDCharacter> clipText;
	
public:
	TextAction(TextObject *obj, guint ch);
	TextAction(TextObject *obj, textaction_deletetype deltype);
	TextAction(TextObject *obj, vector<GDCharacter> clip);
	TextAction(TextStyle &style);
};

#endif
