/* $Id: TextTool.hh,v 1.9 2004/03/30 18:40:47 pklaus Exp $
 *
 * TextTool.hh
 *
 * Gestalter - The free vector drawing application
 * Copyright (c) 2002 Philipp Klaus <gestalter@linotux.ch>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */



#ifndef _TEXTTOOL_HH
#  define _TEXTTOOL_HH

#include "Tool.hh"
#include "DocWindow.hh"
#include <gdk--.h>

class TextObject;
class DocWindow;

class TextTool : public Tool, public SigC::Object {

protected:
	gint downButton;
	gint oldx, oldy;
	gdouble sx, sy;
	
	gboolean nodeCaught;

	Gdk_Cursor TextEditCursor;
	Gdk_Cursor TextRectCursor;
	Gdk_Cursor TextCurveCursor;
	Gdk_Cursor moveCursor;
	Gdk_Cursor moveMagnetCursor;
	
	TextObject *currentObject;
	gboolean coIsActive;
	gboolean cursorDrawing;
	DocWindow *currentDocWin;
	
	void startCursorHandler();

public:
	
	TextTool();
	
	gint cursorHandler();
	
	gboolean drawCursor(void *data);
	
	gint install();
	void activate();
	void deactivate();
	gint buttonDown(GdkEventButton *ev, DocWindow *docwin);
	gint motion(GdkEventMotion *ev, DocWindow *docwin);
	gint buttonUp(GdkEventButton *ev, DocWindow *docwin);
	gint showOptions();
	gint keyPressed(GdkEventKey *ev, DocWindow *docwin);
	
	void setCursor(guint state, DocWindow *docwin);
	
	TextObject *getCurrentObject();
	gboolean editing();
	~TextTool();
	
};

#endif
