/* $Id: Tool.hh,v 1.6 2004/03/31 14:39:25 pklaus Exp $
 *
 * Tool.hh
 *
 * Gestalter - The free vector drawing application
 * Copyright (c) 2002 Philipp Klaus <gestalter@linotux.ch>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */



#ifndef _TOOL_HH
#  define _TOOL_HH

#include <gtk--/window.h>
#include <gtk--/radiobutton.h>

class DocWindow;
class SelectableItem;

class Tool {


protected:
	char **pixmapData;
	int downButton;
	Gtk::RadioButton *button;
	gdouble ox, oy;
	Gdk_Cursor navigateCursor;
	
	guint lastTime;

public:
	gboolean moving;
	gchar *toolName;
	Gtk::Window	*toolWindow;

	Tool();
	Gtk::RadioButton *getNewButton(Gtk::RadioButton_Helpers::Group& group);
	Gtk::RadioButton *getButton();
	virtual void activate();
	virtual void deactivate();
	virtual gint buttonDown(GdkEventButton *ev, DocWindow *docwin);
	virtual gint motion(GdkEventMotion *ev, DocWindow *docwin);
	virtual gint buttonUp(GdkEventButton *ev, DocWindow *docwin);
	virtual gint showOptions(DocWindow *docwin);
	
	virtual gint keyPressed(GdkEventKey *ev, DocWindow *docwin);
	virtual gint keyReleased(GdkEventKey *ev, DocWindow *docwin);
	virtual void setCursor(guint state, DocWindow *docwin);
	
	gboolean magnet(gdouble& x, gdouble& y, DocWindow *docwin);
	
	void drawRectangle(Gdk_Drawable& drawable, Gdk_GC& context,
									gint32 x1, gint32 y1,
									gint32 x2, gint32 y2);
	virtual ~Tool() {};
};
#endif
